var branches;
var buffer;
var exec = require('child_process').execSync;
var regEx;

if(process.argv.length < 2) {
  console.error('Must provide an expression.');
  process.exit(1);
}

regEx = process.argv[2];

console.log('about to switch to master');
_switchToMaster();

buffer = _getBuffer(regEx);
branches = _parseBuffer(buffer);

_removeBranches(branches);

function _getBuffer(regEx) {
  var buffer;

  try {
    buffer = exec('git branch | grep -e ' + regEx + ' | tr "\n" ","');
  } catch(e) {
    console.error('The regular expression provided returns 0 matches.');
    process.exit(1);
  }

  return buffer;
}

function _parseBuffer(buffer) {
  try {
    var output = buffer.toString();

    output = output.substr(0, output.lastIndexOf(','));
    output = output.replace(/[*] /, '');
    output = output.replace(/\s\s/g, '');

    return output.split(',');
  } catch(e) {
    console.error('Unable to parse buffer... exiting.');
    process.exit(1);
  }
}

function _removeBranches(branches) {
  branches.map(function(branch) {
    _removeRemoteBranch(branch);
    _removeLocalBranch(branch);
  });

  function _removeLocalBranch(branch) {
    try {
      exec('git branch -D ' + branch);
    } catch(e) {
      console.error('Local branch doesn\'t exist... skipping.');
    }
  }

  function _removeRemoteBranch(branch) {
    try {
      exec('git push origin :' + branch);
    } catch(e) {
      console.error('Remote branch doesn\'t exist... skipping.');
    }
  }
}

function _switchToMaster() {
  try {
    exec('git co master');
  } catch(e) {
    console.error('Unable to switch to master branch... aborting');
    process.exit(1);
  }
}
